﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "LMItemDrop.generated.h"

class ALMPlayer;
class ULMDropData;

UCLASS()
class LEGUMEMIX_API ALMItemDrop : public AActor
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category=Legumix)
	float TimeBeforeDespawn = 30.f;

	FTimerHandle DespawnHandle;

private:
	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category=Legumix, meta = (AllowPrivateAccess = true))
	TObjectPtr<UStaticMeshComponent> StaticMeshComponent;

public:
	ALMItemDrop();
	virtual void BeginPlay() override;
	
	UFUNCTION(BlueprintCallable)
	virtual void ConsumePack(ALMPlayer* Player);

	UFUNCTION(BlueprintImplementableEvent)
	void OnPackConsumed();

protected:
	UFUNCTION(BlueprintCallable)
	void Despawn();
};
